# README.md

## Settings of Xcode

### Effy.entitlements

AutoFill Credential Provider: YES
App Sandbox: NO
Apple Events: YES

### Project Setting

1. Delete App Sandbox
Project > TARGETS > Signing & Capabilities > App Sandbox

2. Add Hardened Runtime
Set Apple Events to ON
Project > TARGETS > Signing & Capabilities > Hardened Runtime

3. Add "Privacy - AppleEvents Sending Usage Description"
Project > PROJECT > All,Combined > Info.plist Values

## References

### Accessibility API

https://zenn.dev/link/comments/a618f8352f9404

アクセシビリティアクセスのデバッグを便利にする
https://zenn.dev/link/comments/4508ad0951191a

アクセシビリティ設定をシステムから削除する
% sudo tccutil reset Accessibility khnomura.Effy
% sudo tccutil reset AppleEvents khnomura.AppCapture  
% sudo tccutil reset All khnomura.Effy

Sandbox環境下でSystemEventsを動作させる方法

@Effy.entitlements
<key>com.apple.security.temporary-exception.apple-events</key>
<array>
    <string>com.apple.systemevents</string>
</array>

Sandbox環境では、SystemEventsで情報が取得できないアプリは、すべて上の配列で登録が必要です

### Sparkle

https://sparkle-project.org/documentation/

Where is sparkle commands... 
/Users/k_nomura/Library/Developer/Xcode/DerivedData/Effy-XXX/SourcePackages/artifacts/sparkle/Sparkle/bin

手順
1. generate_keysを実行する。秘密鍵と公開鍵が生成される。秘密鍵はキーチェーンへ。公開鍵は、Info.plistのSUPublicEDKeyに設定する
2. バージョンの新旧は、CFBundleVersionで判定される
3. アプリをアーカイブし、ダイレクトディストリビューションを選び、公証する。
4. 指定のフォルダにEffy.appを書き出す。
5. Finderから圧縮
6. generate_appcast . を実行して、appcast.xmlファイルを生成する（必ずコマンドで生成する）
7. appcastファイルとEffy.zipをサーバにアップする

自動チェック・アップデートの実装の仕方
https://sparkle-project.org/documentation/preferences-ui/
